package hpdos_rdma_offloaded.handler;

import org.rocksdb.RocksDB;
import org.rocksdb.Options;
import org.rocksdb.RocksDBException;

public class StorageHandler implements AutoCloseable{

    RocksDB rocksDB;
    Options rockDbOptions;

    public StorageHandler(String dbpath) throws RocksDBException
    {
        System.out.println("Creating RocksDB");
        this.rockDbOptions = new Options();
        rockDbOptions.setCreateIfMissing(true);
        this.rocksDB = RocksDB.open(rockDbOptions,dbpath);
        System.out.println("Created RocksDB");
    }
    public void close()
    {
        rocksDB.close();
        rockDbOptions.close();
        System.out.println("Closing RocksDB instance");
    }

    public void create(byte[] key,byte[] value) throws RocksDBException{
        rocksDB.put(key,value);
    }
    public byte[] read(byte[] key)throws RocksDBException
    {
        return rocksDB.get(key);
    }
    public void update(byte[] key,byte[] value) throws RocksDBException
    {
        rocksDB.put(key,value);
    }
    public void delete(byte[] key) throws RocksDBException
    {
        rocksDB.delete(key);
    }
}